#include <stdio.h>
#include <time.h>
#define BILLION 1E9
#define N 10000

#define M 2

void kernel (double V[], double A[], double TAU, double C[][M]){

	 double V1, T1, V2, T2, V3, T3, V4, T4, SUM, V5, T5, V6, T6, V7, T7, V8, T8;
         int j;
      
         V1 = V[0];
         T1 = TAU*V1;
         V2 = V[1];
         T2 = TAU*V2;

         for(j = 0; j < N; j++){ 
            SUM = V1*A[j];
            C[j][0] = C[j][0] - SUM*T1;
            C[j][1] = C[j][1] - SUM*T2;
         }

}


int main(){

        struct timespec start, end; 
        double runtime;   
	double V[M] = {0.000045, 0.000067};
        double TAU = 1.442;
        double C[N][M];
        double A[N];
        int i, j;
        FILE * exetime = fopen("kernel_runtime", "a");

        clock_gettime(CLOCK_PROCESS_CPUTIME_ID, &start);       
	for (i = 0; i < 100000; i++)
	    kernel (V, A, TAU, C);
        clock_gettime(CLOCK_PROCESS_CPUTIME_ID, &end);

        printf("output: %lf, %lf, %lf \n", C[N/3][0], C[N/2][1], C[N-3][2]);
        runtime = (end.tv_sec - start.tv_sec) + (end.tv_nsec - start.tv_nsec)/BILLION ;
        fprintf(stderr, "runtime = %.10lf!\n", runtime);
  	fprintf(exetime, "%.10lf\n", runtime);
        return 0;

}

