#include <stdio.h>
#include <time.h>
#define BILLION 1E9
#define N 10000

#define M 7

void kernel (double V[], double TAU, double C[][M]){

	 double V1, T1, V2, T2, V3, T3, V4, T4, SUM, V5, T5, V6, T6, V7, T7, V8, T8;
         int j;
      
         V1 = V[0];
         T1 = TAU*V1;
         V2 = V[1];
         T2 = TAU*V2;
         V3 = V[2];
         T3 = TAU*V3;
         V4 = V[3];
         T4 = TAU*V4;
         V5 = V[4];
         T5 = TAU*V5;
         V6 = V[5];
         T6 = TAU*V6;
         V7 = V[6];
         T7 = TAU*V7;

         for(j = 0; j < N; j++){ 
            SUM = V1*C[j][0] + V2*C[j][1] + V3*C[j][2] + V4*C[j][3] + V5*C[j][4] + V6*C[j][5] + V7*C[j][6];
            C[j][0] = C[j][0] - SUM*T1;
            C[j][1] = C[j][1] - SUM*T2;
            C[j][2] = C[j][2] - SUM*T3;
            C[j][3] = C[j][3] - SUM*T4;
            C[j][4] = C[j][4] - SUM*T5;
            C[j][5] = C[j][5] - SUM*T6;
            C[j][6] = C[j][6] - SUM*T7;
         }

}


int main(){

        struct timespec start, end; 
        double runtime;   
	double V[M] = {0.000045, 0.000067, 0.000089, 0.000055, 0.000038, 0.000044, 0.000029};//, 0.000087};
        double TAU = 1.442;
        double C[N][M];
        int i, j;
        FILE * exetime = fopen("kernel_runtime", "a");

        for (i = 0; i < N; i++)
	    for (j = 0; j < M; j++)
                C[i][j] = TAU * i * 579 + V[j] * j;

        clock_gettime(CLOCK_PROCESS_CPUTIME_ID, &start);       
	for (i = 0; i < 100000; i++)
	    kernel (V, TAU, C);
        clock_gettime(CLOCK_PROCESS_CPUTIME_ID, &end);

        printf("output: %lf, %lf, %lf \n", C[N/3][0], C[N/2][1], C[N-3][2]);
        runtime = (end.tv_sec - start.tv_sec) + (end.tv_nsec - start.tv_nsec)/BILLION ;
        fprintf(stderr, "runtime = %.10lf!\n", runtime);
  	fprintf(exetime, "%.10lf\n", runtime);
        return 0;
}

