#include <stdio.h>
#include <time.h>
#define BILLION 1E9
#define N 10000

#define M 64
#define L 20000

void kernel (double rvv[M], double sigmv[M], double xv[M][2], double yv[M][2], double strack[L]){

	 double stracki;
         int i,j;
	 
         for(i = 0; i < L; i++){
              stracki=strack[i];
	      for(j = 0; j < M; j++){
	           xv[j][0]=xv[j][0]+stracki*yv[j][0];
 	           xv[j][1]=xv[j][1]+stracki*yv[j][1];
 	           sigmv[j]=sigmv[j]+stracki*(100.0-rvv[j]*(100.0+(yv[j][0]*yv[j][0]+yv[j][1]*yv[j][1])*0.0005));
  	      }
	 }

}


int main(){

        struct timespec start, end; 
        double runtime;   

	double xv[M][2], yv[M][2], rvv[M], sigmv[M], strack[L];
        int i, j;
        FILE * exetime = fopen("kernel_runtime", "a");
 
        clock_gettime(CLOCK_PROCESS_CPUTIME_ID, &start);       
	for (i = 0; i < 100; i++)
	    kernel (rvv, sigmv, xv, yv, strack);
        clock_gettime(CLOCK_PROCESS_CPUTIME_ID, &end);

        printf("output: %lf, %lf, %lf \n", xv[M/3][0], xv[M/2][1], sigmv[M/5]);
        runtime = (end.tv_sec - start.tv_sec) + (end.tv_nsec - start.tv_nsec)/BILLION ;
        fprintf(stderr, "runtime = %.10lf!\n", runtime);
  	fprintf(exetime, "%.10lf\n", runtime);
        return 0;

}

