##! /usr/local/bin/bash



INPUT_FILE=kernel.c

#remove leftovers
rm *.ll
rm *.s

#generate LLVM IR and apply vectorization
 clang -march=native -O1 -S -emit-llvm $INPUT_FILE -o kernel.ll
 opt -mtriple=x86_64-unknown-linux-gnu -march=core-avx2 -std-compile-opts -adce -S kernel.ll -o kernel.scalar.ll
 opt -mtriple=x86_64-unknown-linux-gnu -march=core-avx2 -std-compile-opts -vectorize-cost-threshold=0 -max-vector-width-in-bit=128 -loop-vectorize -adce -S kernel.ll -o kernel.loopmix.ll 
echo "LLVM IR vectoized"

#generate assembly
 llc -mcpu=core-avx2 -filetype=asm -o kernel.scalar.s kernel.scalar.ll
 llc -mcpu=core-avx2 -filetype=asm -o kernel.loopmix.s kernel.loopmix.ll
echo "assembly generated"

#generate executable
 clang -O3 -march=native -ffast-math kernel.scalar.s -o kernel.scalar -lm
 clang -O3 -march=native -ffast-math kernel.loopmix.s -o kernel.loopmix -lm
echo "executable generated"


